import javafx.scene.transform.Rotate;

/**
 * [hZNg
 */
public class ARSpriteMode extends ARSprite {

	/** [h */
	private		int				mode			= 0;

	/** XY */
	private		Rotate			rotateY			= null;
	private		int				angleY			= 0;

	/**
	 * 
	 */
	public static void init() {

		try{
			ObjReader.init(ARSpriteMode.class, "3d/ship.obj");
		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end init

	/**
	 * RXgN^
	 */
	public ARSpriteMode(ARApplication applicaton){

		// X[p[NXĂяo
		super(applicaton);

		try{

			// Wݒ
			super.setTranslateX(-0.7);
			super.setTranslateY(1.0);
			super.setTranslateZ(10);

			// IuWFNg
			ObjReader.create(this);

			// k
			super.setScaleX(0.02);
			super.setScaleY(0.02);
			super.setScaleZ(0.02);

			// ]
			this.getTransforms().add(new Rotate(180, Rotate.Y_AXIS));

			// Rotate𐶐
			rotateY = new Rotate(angleY, Rotate.X_AXIS);

			// ]pɓo^
			this.getTransforms().add(rotateY);

		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end ARSpriteMode

	/**
	 * s
	 */
	public void run(){

		// pxvZ
		angleY = angleY + ((mode == 0)?-4: 4);

		angleY = (angleY > 360)?angleY - 360: angleY;
		angleY = (angleY < 0)?angleY + 360: angleY;

		// pxݒ
		rotateY.setAngle(angleY);

	} // end run

	/**
	 * [hݒ
	 */
	public void setMode(int mode){

		// [hێ
		this.mode = mode;

		// ʒuݒ
		super.setTranslateY(1.0 + mode * 0.2);

	} // end run

}
