import javafx.geometry.Point3D;

/**
 * ^Cg|3D
 */
public class ARSpriteTitle3D extends ARSprite implements ARConstant {

	/** tF[Y */
	private		int				phase		= 0;

	/**  */
	private		int				time		= 0;

	/** ]x */
	private		double			s			= 6.0;

	/** xX */
	private		double			mx			= 0.32;

	/** xZ */
	private		double			mz			= -1.6;

	/**
	 * 
	 */
	public static void init() {

		try{
			ObjReader.init(ARSpriteTitle3D.class, "3d/3D.obj");
		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end init

	/**
	 * RXgN^
	 * @param application ARApplication
	 */
	public ARSpriteTitle3D(ARApplication application){

		// X[p[NXĂяo
		super(application);

		try{

			// IuWFNg
			ObjReader.create(this);

			// g傷
			super.setScaleX(1.5);
			super.setScaleY(1.5);
			super.setScaleZ(1.5);

			// Yݒ
			super.setTranslateY(0.2);

			// ]
			Point3D p = new Point3D(0.0, 1.0, 0.0);

			// ]
			super.setRotate(45);

			// ]ݒ
			super.setRotationAxis(p);

		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end ARSpriteAsteroid

	/**
	 * s
	 */
	public void run(){

		// tF[YO
		if(phase == 0){

			// ԏ
			time = 0;

			// tF[YP
			phase = 1;

		// tF[YP
		}else if(phase == 1){

			// W擾
			double x = super.getTranslateX();
			double z = super.getTranslateZ();

			// ʒuɗ܂ŁA
			if(z > 14){

				// WZ
				x = x + mx;
				z = z + mz;

				// ʂ̊OɂłꍇA
				if(z < 0){
					// \ɂ
					super.setVisible(false);;
				}

				// ړ
				super.setTranslateX(x);
				super.setTranslateZ(z);

			// ʒuɗA
			}else{
				// ԏ
				time = 0;
				// tF[YQ
				phase = 2;
			}

		// tF[YQ
		}else if(phase == 2){

			// ԁ{P
			time++;

			// ԂoA
			if(time > 60){

				// ԏ
				time = 0;
				// tF[YR
				phase = 3;

			}

		// tF[YR
		}else if(phase == 3){

			// ]
			super.setRotate(getRotate() + this.s);

		}

	} // end run

	/**
	 * 
	 */
	public void initPosition(){

		// tF[YO
		phase = 0;

		// Xݒ
		super.setTranslateX(-55.5);

		// Zݒ
		super.setTranslateZ(300);

		// ]
		super.setRotate(0);

	} // end initPosition

	/**
	 * ^CgXLbv
	 */
	public void skipTitle(){

		// Yݒ
		super.setTranslateX(1.78);
		// Zݒ
		super.setTranslateZ(13.6);

		// ԏ
		time = 0;

		// tF[YQ
		phase = 2;

	} // end skipTitle

}
