import javafx.geometry.Point3D;

/**
 * ^Cg|AXeC_[
 */
public class ARSpriteTitleAsteroider extends ARSprite implements ARConstant {

	/** tF[Y */
	private		int				phase		= 0;

	/**  */
	private		int				time		= 0;

	/** ]x */
	private		double			s			= 2.0;

	/** xY */
	private		double			my			= 0.32;

	/** xZ */
	private		double			mz			= -1.6;

	/**
	 * 
	 */
	public static void init() {

		try{
			ObjReader.init(ARSpriteTitleAsteroider.class, "3d/ASTEROIDER.obj");
		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end init

	/**
	 * RXgN^
	 * @param application ARApplication
	 */
	public ARSpriteTitleAsteroider(ARApplication application){

		// X[p[NXĂяo
		super(application);

		try{

			// IuWFNg
			ObjReader.create(this);

			// ]
			Point3D p = new Point3D(0.0, -0.1, 0.0);

			// ]ݒ
			super.setRotationAxis(p);

		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end ARSpriteAsteroid

	/**
	 * s
	 */
	public void run(){

		// tF[YO
		if(phase == 0){

			// ԏ
			time = 0;

			// tF[YP
			phase = 1;

		// tF[YP
		}else if(phase == 1){

			// W擾
			double y = super.getTranslateY();
			double z = super.getTranslateZ();

			// ʒuɗ܂ŁA
			if(z > 14){

				// WZ
				y = y + my;
				z = z + mz;

				// ʂ̊OɂłꍇA
				if(z < 0){
					// \ɂ
					super.setVisible(false);;
				}

				// ړ
				super.setTranslateY(y);
				super.setTranslateZ(z);

			// ʒuɗA
			}else{
				// ԏ
				time = 0;
				// tF[YQ
				phase = 2;
			}

		// tF[YQ
		}else if(phase == 2){

			// ԁ{P
			time++;

			// ԂoA
			if(time > 60){

				// ԏ
				time = 0;
				// tF[YR
				phase = 3;

				// tF[Yݒ
				super.application.setPhase(PHASE_TITLE_3);

			}

		// tF[YR
		}else if(phase == 3){

			// ]
			super.setRotate(getRotate() + this.s);

		}

	} // end run

	/**
	 * 
	 */
	public void initPosition(){

		// tF[YO
		phase = 0;

		// Yݒ
		super.setTranslateY(-58.0);

		// Zݒ
		super.setTranslateZ(300);

		// ]
		super.setRotate(0);

	} // end initPosition

	/**
	 * ^CgXLbv
	 */
	public void skipTitle(){

		// Yݒ
		super.setTranslateY(-0.72);
		// Zݒ
		super.setTranslateZ(13.6);

		// ԏ
		time = 0;

		// tF[YQ
		phase = 2;

	} // end skipTitle

}
